$(document).ready(function(){
	
	var editOpen = false;
	var editId = '';
	var editText = '';
	var pieceCounter = 0;
	
	$(document).keydown(function(e){
		// alert( e.keyCode );
		if( editOpen == false ){
			if ( e.keyCode == 8 ){
				// BACKSPACE KEY
				e.preventDefault();
				$('#text-cursor').prev().remove();
			} else if( e.keyCode == 32 ){
				
			} else if( e.keyCode == 37 ){
			// LEFT ARROW							
				if( $('#text-cursor').is('#content :first-child') ){

				} else {
						$('#text-cursor').prev().before('<div id="text-cursor-new"><span></span></div>');						
						$('#text-cursor').remove();
						$('#text-cursor-new').attr('id','text-cursor');
				}
			} else if( e.keyCode == 39 ){
			// RIGHT ARROW
				if( $('#text-cursor').is('#content :last-child') ){

				} else {
					$('#text-cursor').next().after('<div id="text-cursor-new"><span></span></div>');						
					$('#text-cursor').remove();
					$('#text-cursor-new').attr('id','text-cursor');
				}
			} else if( e.keyCode == 36 ){
			// "HOME" KEY
				$('#content :first-child').before('<div id="text-cursor-new"><span></span></div>');						
				$('#text-cursor').remove();
				$('#text-cursor-new').attr('id','text-cursor');
			} else if( e.keyCode == 35 ){
			// "END" KEY
				$('#content :last-child').after('<div id="text-cursor-new"><span></span></div>');						
				$('#text-cursor').remove();
				$('#text-cursor-new').attr('id','text-cursor');
			}
		}
	});
	
	// KEYPRESS FUNCTIONALITY TO ESC OUT OF MODAL POPUPS
	$(document).keyup(function(e) {
	  if (e.keyCode == 27) {
		if( editOpen == true ){
			$('#edit-box').fadeOut( 300 );
			editOpen = false;
		}
	  }
	});
	
	$(document).keypress(function(e){
		// GET KEYCODE FOR TESTING
		// alert( e.keyCode );
		if( editOpen == false ){
			if ( e.keyCode == 8 ){
			} else if( e.keyCode == 13 ) {
				// ENTER KEY - COMMITS TEXT TO DIV
				contentString = '';
				$('#content .letter').each(function(){
					if( $(this).html() == '&nbsp;' ){
						contentString += ' ';
					} else {
						contentString += $(this).html();
					}
				});
				$('#content .letter').remove();
				if( contentString == '' ){
					if( $('#text-cursor').prev().hasClass('new-line') ){
						$('#text-cursor').before( '<span id="piece-' + pieceCounter + '"  class="committed-text new-line blank-line"></span>' );
					} else {
						$('#text-cursor').before( '<span id="piece-' + pieceCounter + '"  class="committed-text new-line"></span>' );
					}
				} else {
					$('#text-cursor').before( '<span id="piece-' + pieceCounter + '"  class="committed-text">' + contentString + ' </span>' );
				}
			} else if( e.keyCode == 32 ) {
				// SPACE CHARACTER
				e.preventDefault();
				$('#text-cursor').before( '<span id="piece-' + pieceCounter + '" class="letter">&nbsp;</span>' );
			} else {
				var c = String.fromCharCode(e.which);
				$('#text-cursor').before( '<span id="piece-' + pieceCounter + '"  class="letter">' + c + '</span>' );
			}
			pieceCounter++;
		} else {
			// IF EDIT BOX IS OPEN ENTER WILL TRIGGER OK
			if( e.keyCode == 13 ) {
				$('.edit-ok').trigger('click');
			}
		}
	});
	
	$('#content').on('click','.committed-text',function(){
		$('.editing-text').removeClass('editing-text');
		$(this).addClass('editing-text');
		editText = $(this).html();
		editId = '#' + $(this).attr('id');
		editPosition = $(this).offset();
		
		if( $(this).hasClass('bold') ){ $('.edit-button-bold').addClass('active'); } else {	$('.edit-button-bold').removeClass('active'); }
		if( $(this).hasClass('italic') ){ $('.edit-button-italic').addClass('active'); } else {	$('.edit-button-italic').removeClass('active'); }
		if( $(this).hasClass('underline') ){ $('.edit-button-underline').addClass('active'); } else {	$('.edit-button-underline').removeClass('active'); }
		if( $(this).hasClass('h1') ){ $('.edit-button-h1').addClass('active'); } else {	$('.edit-button-h1').removeClass('active'); }
		if( $(this).hasClass('h2') ){ $('.edit-button-h2').addClass('active'); } else {	$('.edit-button-h2').removeClass('active'); }
		
		$('#edit-box .edit-input').val( editText );
		$('#edit-box').css('top', ( editPosition.top + 40 ) ).css('left', editPosition.left );
		$('#edit-box').fadeIn( 100 );
		editOpen = true;
	});
	
	$('.edit-ok').click(function(){
		$('.editing-text').html( $('.edit-input').val() );
		$('.editing-text').removeClass('editing-text');
		editOpen = false;
		$('#edit-box').fadeOut( 100 );
	});
	
	$('.edit-close').click(function(){
		$('.editing-text').removeClass('editing-text');
		editOpen = false;
		$('#edit-box').fadeOut( 100 );
	});
	
	$('.edit-button-bold').click(function(){
		if( $(editId).hasClass('bold') ){
			$(editId).removeClass('bold');
			$('.edit-button-bold').removeClass('active');
		} else {
			$(editId).addClass('bold');
			$('.edit-button-bold').addClass('active');
		}
	});
	
	$('.edit-button-italic').click(function(){
		if( $(editId).hasClass('italic') ){
			$(editId).removeClass('italic');
			$('.edit-button-italic').removeClass('active');
		} else {
			$(editId).addClass('italic');
			$('.edit-button-italic').addClass('active');
		}
	});
	
	$('.edit-button-underline').click(function(){
		if( $(editId).hasClass('underline') ){
			$(editId).removeClass('underline');
			$('.edit-button-underline').removeClass('active');
		} else {
			$(editId).addClass('underline');
			$('.edit-button-underline').addClass('active');
		}
	});
	
	$('.edit-button-h1').click(function(){
		if( $(editId).hasClass('h1') ){
			$(editId).removeClass('h1');
			$('.edit-button-h1').removeClass('active');
		} else {
			$(editId).addClass('h1');
			$('.edit-button-h1').addClass('active');
			$(editId).removeClass('h2');
			$('.edit-button-h2').removeClass('active');
		}
	});
	
	$('.edit-button-h2').click(function(){
		if( $(editId).hasClass('h2') ){
			$(editId).removeClass('h2');
			$('.edit-button-h2').removeClass('active');
		} else {
			$(editId).addClass('h2');
			$('.edit-button-h2').addClass('active');
			$(editId).removeClass('h1');
			$('.edit-button-h1').removeClass('active');
		}
	});
});